import re,os,logging
from select import select

log = logging.getLogger("ipv6world")

class MultiInput:
    re_cmdsep=re.compile("(\r\n|\r|\n)")
    def __init__(self, *args):
        self.monitor = map(self.get_fileno, args)
        self.bufs = [""]*len(args)

    def get_fileno(self, f):
        if type(f) is int:
            return f
        return f.fileno()

    def add_fd(self, fd):
        self.monitor.append(self.get_fileno(fd))
        self.bufs.append("")

    def get_pipe(self):
        r,w = os.pipe()
        self.add_fd(r)
        return os.fdopen(w, "w", 0)

    def extract_line(self):
        for i in range(len(self.bufs)):
            b = self.bufs[i]
            s = self.re_cmdsep.split(b,1)
            if len(s) == 3:
                l,_,b = s
                l = l.strip()
                self.bufs[i] = b
                return l                

    def get_command(self):
        while 1:
            cmd = self.extract_line()
            if cmd:
                log.debug("-*-*-*-[ %r ]-*-*-*-" % cmd)
                return cmd
            r,w,e = select(self.monitor,[],[])
            for i in range(len(self.monitor)):
                fd = self.monitor[i]
                if fd in r:
                    self.bufs[i] += os.read(fd,8192)
